/**
 * apeman task to run apeman dply command.
 * @memberof module:apeman-task-dply/lib
 * @function define
 * @param {object} [options] - Optional settings.
 * @returns {function} - Defined task function.
 */

'use strict'

const apemanDply = require('apeman-dply')
const co = require('co')

/** @lends define */
function define (options = {}) {
  /**
   * Defined task.
   * @function task
   * @param {object} context - Apeman task context.
   * @returns {Promise}
   */
  function task (context) {
    let { logger, verbose } = context

    return co(function * () {
      return yield apemanDply({
        configuration: options.configuration || context.apemanfile,
        verbose: verbose,
        list: options.list,
        delete: options.delete,
        pattern: options.pattern,
        force: options.force
      })
    })
  }

  // Description of this task.
  task.$desc = 'Run apeman dply command.'
  return task
}

module.exports = define
