/**
 * Test case for define.
 * Runs with mocha.
 */
'use strict'

const define = require('../lib/define.js')
const apemanInfr = require('apeman-infr')
const co = require('co')
const assert = require('assert')

describe('define', function () {
  this.timeout(48000)
  
  let Apemanfile = require.resolve('../doc/mocks/mock-project/Apemanfile')

  function noop () {
  }

  before(() => co(function * () {
    yield apemanInfr({
      configuration: Apemanfile
    })
  }))

  after(() => co(function * () {
    yield apemanInfr({
      delete: true,
      configuration: Apemanfile,
      force: true
    })
  }))

  it('Define', () => co(function * () {
    let createTask = define({
        configuration: Apemanfile
      }),
      deleteTask = define({
        delete: true,
        configuration: Apemanfile
      })
    assert.ok(createTask)
    assert.ok(deleteTask)
    let context = {
      verbose: false,
      logger: {
        info: noop,
        debug: noop,
        trace: noop
      }
    }
    yield createTask(context)
    deleteTask(context)
  }))
})

/* global describe, before, after, it */